///+------------------------------------------------------------------+
//|                                                Pat_for_vspexp.mq5 |
//|                                     Copyright 2013, Prozorov A.V. |
//|                                                  prozavf@mail.ru  |
//+-------------------------------------------------------------------+
#property copyright "Copyright 2013, Prozorov A.V."
#property link      "prozavf@mail.ru"
#property version   "1.00"
 

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_plots   1
//--- plot ColorCandles
#property indicator_label1  "Pat_for_vspexp"
#property indicator_type1   DRAW_COLOR_CANDLES
//---  8     (    )
#property indicator_color1  clrPaleGreen,clrRed,clrBlue,clrOrange
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
 
//--- input 
input bool     messages=false;      

input int History=200;
input int AnalyseMode=0;  // Analyse Mode 0 -open/close  >0 = high/low
input color Rally_color=clrPaleGreen;
input color Reaction_color=clrRed;
input color Inside_color=clrBlue;
input color Outside_color=clrOrange;


//---  
double         ColorCandlesBuffer1[];
double         ColorCandlesBuffer2[];
double         ColorCandlesBuffer3[];
double         ColorCandlesBuffer4[];
double         ColorCandlesColors[];
int            candles_colors;
int            bars;
//---  
string symbol;

color colors[4];
int N=1;
string pref="vspexp";


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {

//--- indicator buffers mapping
   SetIndexBuffer(0,ColorCandlesBuffer1,INDICATOR_DATA);
   SetIndexBuffer(1,ColorCandlesBuffer2,INDICATOR_DATA);
   SetIndexBuffer(2,ColorCandlesBuffer3,INDICATOR_DATA);
   SetIndexBuffer(3,ColorCandlesBuffer4,INDICATOR_DATA);
   SetIndexBuffer(4,ColorCandlesColors,INDICATOR_COLOR_INDEX);

   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);
   symbol=_Symbol;
//---    
   PlotIndexSetString(0,PLOT_LABEL,symbol+" Open;"+symbol+" High;"+symbol+" Low;"+symbol+" Close");
   IndicatorSetString(INDICATOR_SHORTNAME,"Pat_for_vspexp("+symbol+")");
//----     
   
   candles_colors=4;     //  .    #property indicator_color1
   colors[0]=Rally_color;
   colors[1]=Reaction_color;
   colors[2]=Inside_color;
   colors[3]=Outside_color; 
   bars=History+100;
   
   
//--- 
   return(0);
  }
  void OnDeinit(const int reason)
  {
//---
   
   EraseAll(pref);
   Sleep(500);
  }
  
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
  
    
      symbol=_Symbol;
      
      EraseAll(pref);
      int tries=0;
      //---  5    plot1   symbol
      while(!CopyFromSymbolToBuffers(symbol,rates_total,0,
            ColorCandlesBuffer1,ColorCandlesBuffer2,ColorCandlesBuffer3,
            ColorCandlesBuffer4,ColorCandlesColors,candles_colors)
            && tries<5)
        {
         //---    CopyFromSymbolToBuffers()
         tries++;
        }
        ChartRedraw();
     
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
bool CopyFromSymbolToBuffers(string name,
                             int total,
                             int plot_index,
                             double &buff1[],
                             double &buff2[],
                             double &buff3[],
                             double &buff4[],
                             double &col_buffer[],
                             int    cndl_colors
                             )
  {
//---   rates[]    Open, High, Low  Close
   MqlRates rates[];
//---  
   int attempts=0;
//---  
   int copied=0;
//---  25      
   while(attempts<25 && (copied=CopyRates(name,_Period,0,bars,rates))<0)
     {
      Sleep(100);
      attempts++;
      if(messages) PrintFormat("%s CopyRates(%s) attempts=%d",__FUNCTION__,name,attempts);
     }
//---       
   if(copied!=bars)
     {
      //---   
      string comm=StringFormat("  %s    %d   %d ",
                               name,
                               copied,
                               bars
                               );
      //---        
      Comment(comm);
      //---  
      if(messages) Print(comm);
      return(false);
     }
   else
     {
      //---    
      PlotIndexSetString(plot_index,PLOT_LABEL,name+" Open;"+name+" High;"+name+" Low;"+name+" Close");
      IndicatorSetString(INDICATOR_SHORTNAME,"DRAW_COLOR_CANDLES("+symbol+")");
     }
//---    
   ArrayInitialize(buff1,0.0);
   ArrayInitialize(buff2,0.0);
   ArrayInitialize(buff3,0.0);
   ArrayInitialize(buff4,0.0);
//---       
   for(int i=0;i<copied;i++)
     {
      //---     
      int buffer_index=total-copied+i;
      //---    
    //  int color_index=Getcolor(buffer_index, rates);
        int color_index=Getcolor(i, rates);
    //    int color_index=2;
      if (color_index<candles_colors)
      {
         buff1[buffer_index]=rates[i].open;
         buff2[buffer_index]=rates[i].high;
         buff3[buffer_index]=rates[i].low;
         buff4[buffer_index]=rates[i].close;
      //---   
      
         col_buffer[buffer_index]=color_index;
      }   
     }
   return(true);
  }


  
  int Getcolor(int i, MqlRates &rates[])
  {
    int k=0;
    
    int m= candles_colors+10;
    k= isRally(i,rates) ;
    if (k>0) m=0;
    k= isReaction(i,rates) ;
    if (k>0) m=1;
    k= isInside(i,rates) ;
    if (k>0) 
    {
        m=2;
  
        OutPat(i,k,Inside_color, rates);
    }
    k= isOutside(i,rates) ;
    if (k>0){ m=3; OutPat(i,k,Outside_color,rates);}
  
    return(m);
  
  }  
  
  int isRally(int i,MqlRates &rates[])
  {
 //    Print ("---------->  i ratesSize  ",i,"   ",ArraySize(rates));
     int k=0;
     int lim=40;
     if (i<41) lim=i-1;
     for (int l=1; l<=lim; l++)
     {
         if (l>k+1) l=lim+1;
         else
         {
           if (AnalyseMode==0)
           {
             if (MathMax(rates[i].open,rates[i].close)>MathMax(rates[i-l].open,rates[i-l].close)
                &&MathMin(rates[i].open,rates[i].close)>=MathMin(rates[i-l].open,rates[i-l].close))k++;
           }
           else
           {
              if (rates[i].high>rates[i-l].high&&rates[i].low>=rates[i-l].low)k++;
           }    
         }
     } 
  
  
    return (k);
  }  
  
  int isInside(int i,MqlRates &rates[])
  {
     int k=0;
     int lim=40;
     if (i<41) lim=i-1;
     for (int l=1; l<=lim; l++)
     {
         if (l>k+1) l=lim+1;
         else
         {
           if (AnalyseMode==0)
           {
             if ((MathMin(rates[i].open,rates[i].close)>MathMin(rates[i-l].open,rates[i-l].close))
             &&(MathMax(rates[i].open,rates[i].close)<MathMax(rates[i-l].open,rates[i-l].close)))k++;
           }
           else
           {
              if ((rates[i].high<rates[i-l].high)&&(rates[i].low>rates[i-l].low))k++;
           }    
         }
     } 
  
  
    return (k);
  }  
  
  int isReaction(int i,MqlRates &rates[])
  {
     int k=0;
     int lim=40;
     if (i<41) lim=i-1;
     for (int l=1; l<=lim; l++)
     {
         if (l>k+1) l=lim+1;
         else
         {
           if (AnalyseMode==0)
          {
             if ((MathMin(rates[i].open,rates[i].close)<MathMin(rates[i-l].open,rates[i-l].close))
             &&(MathMax(rates[i].open,rates[i].close)<=MathMax(rates[i-l].open,rates[i-l].close)))k++;
           }
           else
           {
              if ((rates[i].high<=rates[i-l].high)&&(rates[i].low<rates[i-l].low))k++;
           }   
         }
     } 
  
  
    return (k);
  }  
  
  int isOutside(int i,MqlRates &rates[])
  {
     int k=0;
     int lim=40;
     if (i<41) lim=i-1;
     for (int l=1; l<=lim; l++)
     {
         if (l>k+1) l=lim+1;
         else
         {
           if (AnalyseMode==0)
           {
             if ((MathMin(rates[i].open,rates[i].close)<MathMin(rates[i-l].open,rates[i-l].close))
             &&(MathMax(rates[i].open,rates[i].close)>MathMax(rates[i-l].open,rates[i-l].close)))k++;
           }
           else
           {
              if ((rates[i].high>rates[i-l].high)&&(rates[i].low<rates[i-l].low))k++;
           }    
         }
     } 
  
  
    return (k);
  } 
  
  int OutPat(int i,int k,color Patcol, MqlRates &rates[])
  {
        double x1;
        double x2;
        if (AnalyseMode==0)
        {
           x1=rates[i].open;
           x2=rates[i].close;
        }
        else
        {
           x1=rates[i].low;
           x2=rates[i].high;
        }
        
        
        datetime t1=rates[i-k].time;
        datetime t2=rates[i].time;
        if (Patcol==Inside_color&&i<ArraySize(rates)-1) t2=rates[i+1].time;
        
        string name=pref+IntegerToString(i)+"_"+IntegerToString(k);
        ObjectCreate (0,name,OBJ_RECTANGLE,0,t1,x1,t2,x2);
        ObjectSetInteger(0,name, OBJPROP_COLOR, Patcol);
        ObjectSetInteger(0,name, OBJPROP_WIDTH, 1);
        ObjectSetInteger(0,name,OBJPROP_STYLE,STYLE_DOT);
       
    return (0);
  }  
  
int EraseAll(string pr)
{
  for (int i=ObjectsTotal(0,0,-1)-1;i>=0 ;i--)
      {
         string  name=ObjectName(0,i,0,-1);
         if  (StringFind(name,pr,0)==0) ObjectDelete(0,name);
      }
      
  return(0);
}   